import { BehaviorSubject, Observable, Subject } from "rxjs";
import dotenv from 'dotenv';
import { AdapterInterface, ConnectionState, TransmissionRole, TransportType, TransportServiceInterface, AdapterProfile } from "../interface/interface";

dotenv.config();
/* This transport manager will be instantiating the necessary transport to deal with tranmission and receiving from different receivers
So how?: */
export class AdapterBase implements AdapterInterface {
    protected AdapterProfile!: AdapterProfile
    // protected clientId!: string
    // protected transportService!: TransportServiceInterface
    // protected role!: TransmissionRole;
    // protected connectionState!: Subject<ConnectionState>
    // protected transport: TransportType;

    constructor() {
        //logic here
    }

    setAdapterProfile(clientId: string, adapterType: TransportType, transportService: TransportServiceInterface, role: TransmissionRole): void {
        this.AdapterProfile.clientId = clientId
        this.AdapterProfile.connectionState = new BehaviorSubject<ConnectionState>(`OFFLINE`)
        this.AdapterProfile.role = role
        this.AdapterProfile.transportType = adapterType
        this.AdapterProfile.transportService = transportService
    }

    getAdapterProfile(type?: `clientId` | `role` | `transportId` | `transportType` | `connectionState`): string | BehaviorSubject<ConnectionState> | AdapterProfile | undefined {
        if (!type) {
            return this.AdapterProfile
        } else if (type == `clientId`) {
            return this.AdapterProfile.clientId
        } else if (type == `connectionState`) {
            return this.AdapterProfile.connectionState
        } else if (type == `role`) {
            return this.AdapterProfile.role
        } else if (type == `transportType`) {
            return this.AdapterProfile.transportType
        } else if (type == `transportId`) {
            return this.AdapterProfile.transportService.getInfo().transportServiceId
        }

    }
}


