
import { Observable, Observer, Subject, Unsubscribable } from 'rxjs';
import { ClientObject, GeneralEvent, MessageReceiverInterface, MessageRequestResponseInterface, MessageTransmissionInterface, MessageTransmissionManagerInterface, MessageTransmitterInterface } from '../interface/interface';
import { ActorInterface, ActorProfile } from '../interface/actor.sample';
import { ActorBase } from './actor.base';
import { AdapterManager } from '../adapters/adapter.manager';

export class MessageTransmissionManagerBase implements MessageTransmissionManagerInterface {
    protected browserEnv!: boolean
    protected tranmissionRef: MessageTransmissionInterface[] = []
    protected adapterManager!: AdapterManager
    protected event!: Subject<GeneralEvent<any>>

    constructor() {
        // logic here
    }
    
    getTransmitter(receiverId: string): MessageTransmitterInterface {
        throw new Error(`Method not implemented`)
    }

    getReceiver(transmitterid: string): MessageReceiverInterface {
        throw new Error(`Method not implemented`)
    }

    getRequestResponse(clientId: string, transmitterInstance: MessageTransmitterInterface, receiverInstance: MessageReceiverInterface): MessageRequestResponseInterface {
        throw new Error(`Method not implemented`)
    }

}